#ifndef MODEL_HPP
#define MODEL_HPP

#include "protocols.hpp"

#include <QSortFilterProxyModel>
#include <QStandardItemModel>

class Model : public QObject {
    Q_OBJECT

  public:
    enum supportFilters {
        ALL,
        SUPPORTED,
        UNSUPPORTED
    };

  private:
    QSortFilterProxyModel searchModel;
    QSortFilterProxyModel supportModel;
    QString searchFilter;
    supportFilters supportFilter;

  public:
    Model(ProtocolSource source);
    ~Model();

    QStandardItemModel sourceModel;
    QSortFilterProxyModel* const filteredModel;
    QString const name;
    bool const includeStatus;
    bool const includeName;

    void setSearchFilter(const QString& searchFilter);

    void setSupportFilter(const supportFilters supportFilter);

    void updateFilter();

  signals:
    void filterChanged(bool filtering);
};

#endif
